/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


package actions;

import java.awt.event.ActionEvent;
import javax.swing.KeyStroke;
import objets.CCalculComplexe;
import objets.CListeObjets;
import dialogs.CalculComplexeDlg;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

@SuppressWarnings("serial")
public class ActionCreerCalculComplexe extends MtgAction {
  public ActionCreerCalculComplexe(MtgFrame frameInit) {
    super(frameInit, null, getString("chaineMenuCreerCalculComplexe"),
    		null, null, KeyStroke.getKeyStroke('E', java.awt.event.InputEvent.SHIFT_MASK | java.awt.event.InputEvent.CTRL_MASK  ));
  }
  
  @Override
  public int idMenu() {
    return 33133;
  }
  
	@Override
	public void actionPerformed(ActionEvent e) {
		super.actionPerformed(e);
    frame.actionEnCours = this;
    MtgInternalFrame cadre = frame.cadreActif();
    CListeObjets listePr = cadre.listePr;
    frame.indication("");
    CCalculComplexe cal = new CCalculComplexe(listePr, null, false);    
    CalculComplexeDlg dlg = new CalculComplexeDlg(frame, cal, false);
		dlg.setLocationRelativeTo(frame);
    dlg.setVisible(true);
    if (dlg.retourOK()) {
      if (frame.ajouteElementAvecVerification(cal))
        cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil20"));    	
    }
    frame.actionEnCours = this;
    frame.activeOutilCapture();
  }
  
  // Pas d'icne associe  cet outil
}
