/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package actions;

import java.awt.event.ActionEvent;
import java.net.URL;
import javax.swing.ImageIcon;
import javax.swing.KeyStroke;

import objets.CCalcul;
import objets.CListeObjets;
import dialogs.CalculReelDlg;

import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

/**
 *
 * @author Yves
 */
@SuppressWarnings("serial")
public class ActionCreerCalculReel extends MtgAction {
  public ActionCreerCalculReel(MtgFrame frameInit) {
    super(frameInit, null, getString("chaineMenuCreerCalcul"),
    		getString("chaineTipCreerCalcul"), iconeAssociee(frameInit), KeyStroke.getKeyStroke('E', java.awt.event.InputEvent.CTRL_MASK  ));
  }
  
  @Override
  public int idMenu() {
    return 32879;
  }
  
  public static ImageIcon iconeAssociee(MtgFrame frame) {
  	String ch;
  	if (frame.pref_LittleIconSize) ch = ""; else ch = "Big";
    URL adr = MtgFrame.class.getResource("images/Calcul" + ch + ".png");
    return new ImageIcon(adr);    
  }
  
	@Override
	public void actionPerformed(ActionEvent e) {
    //frame.actionEnCours = this;
		super.actionPerformed(e);
    MtgInternalFrame cadre = frame.cadreActif();
    CListeObjets listePr = cadre.listePr;
    frame.indication("");
    CCalcul cal = new CCalcul(listePr, null, false);    
    CalculReelDlg dlg = new CalculReelDlg(frame, cal, false);
		dlg.setLocationRelativeTo(frame);
    dlg.setVisible(true);
    if (dlg.retourOK()) {
      if (frame.ajouteElementAvecVerification(cal))
        cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil20"));    	
    }
    frame.actionEnCours = this;
    frame.activeOutilCapture();
  }    
}
