/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package actions;

import java.net.URL;
import javax.swing.ImageIcon;
import javax.swing.KeyStroke;

import mathgraph32.MtgFrame;

@SuppressWarnings("serial")
public class ActionCreerDroiteParEquation extends MtgAction {
  public ActionCreerDroiteParEquation(MtgFrame frameInit) {
    super(frameInit, frameInit.outilDroiteParEquation, getString("chaineMenuCreerDroiteParEq"),
    		getString("chaineTipCreerDroiteParEq"), iconeAssociee(frameInit), KeyStroke.getKeyStroke("control Q"));
  }
  
  @Override
  public int idMenu() {
    return 32016;
  }
  
  public static ImageIcon iconeAssociee(MtgFrame frame) {
  	String ch;
  	if (frame.pref_LittleIconSize) ch = ""; else ch = "Big";
    URL adr = MtgFrame.class.getResource("images/DteParEq" + ch + ".png");
    return new ImageIcon(adr);    
  }

}
