/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package actions;

import java.awt.Desktop;
import java.awt.event.ActionEvent;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.net.URLDecoder;
import javax.swing.KeyStroke;
import mathgraph32.MtgFrame;

@SuppressWarnings("serial")
public class ActionHelpHelp extends MtgAction {
	public ActionHelpHelp(MtgFrame frameInit) {
		super(frameInit, null, getString("chaineMenuHelpHelp") , null, null, KeyStroke.getKeyStroke("F1"));
	}
	
	// Ajout version 4.3 pour que l'outil puisse tre activ ou non
  @Override
  public int idMenu() {
    return 32022;
  }	

	@Override
	public void actionPerformed(ActionEvent e) {
		if(Desktop.isDesktopSupported()){		
			if(Desktop.getDesktop().isSupported(Desktop.Action.BROWSE)){
		    String path = "/" + MtgFrame.class.getName().replace('.', '/') + ".class";
		    URL url = getClass().getResource(path);
		    try {
					path = URLDecoder.decode(url.toString(), "UTF-8");
				} catch (UnsupportedEncodingException e2) {
					messageErreur();
					return;
				}
		    int index = path.lastIndexOf("/");
		    path = path.substring(0, index);
		    
		    // On enlve le jar:file: du dbut si ncessaire
		    if (path.startsWith("jar:file:"))
		    {
		      index = path.indexOf("!");
		      path = path.substring(9, index);
		    }
		    if (path.startsWith("/")) path = path.substring(1);
		    // On remonte de un niveau
		    index = path.lastIndexOf("/");
		    path = path.substring(0, index);
		    if (path.startsWith("file:/")) path = path.substring(6);
		    // Si la langue systme n'est pas supporte, l'aide sera en Anglais
				try {
					String path2 = "file:///" + path + "/Help" + frame.pref_langage + "/HTML/MathGraph32Help.htm";
					path2 = path2.replaceAll(" ", "%20");
					Desktop.getDesktop().browse(new URI(path2));
				} catch (IOException e1) {
					String path3 = "file:///" + path + "/HTML/Helpeng/MathGraph32Help.htm";
					path3 = path3.replaceAll(" ", "%20");
					try {
						Desktop.getDesktop().browse(new URI(path3));
					} catch (IOException e2) {
						messageErreur();
					} catch (URISyntaxException e2) {
						messageErreur();
					}
				} catch (URISyntaxException e1){
					messageErreur();
					return;
				}
			}
		}
	}
	
	private void messageErreur() {
		frame.dialogueAvertissement(getString("ch157"));
	}
}
