/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package actions;

import java.net.URL;

import javax.swing.ImageIcon;

import mathgraph32.MtgFrame;

@SuppressWarnings("serial")
public class ActionTangente extends MtgAction {

	public ActionTangente(MtgFrame frameInit) {
		super(frameInit, frameInit.outilTangente, getString("chaineMenuCreerTangente"),
				getString("chaineMenuCreerTangente"), iconeAssociee(frameInit), null);
	}

  @Override
  public int idMenu() {
    return 33003;
  }

  public static ImageIcon iconeAssociee(MtgFrame frame) {
  	String ch;
  	if (frame.pref_LittleIconSize) ch = ""; else ch = "Big";
    URL adr = MtgFrame.class.getResource("images/Tangente" + ch + ".png");
    return new ImageIcon(adr);    
  }

}
