/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package dialogs;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

@SuppressWarnings("serial")
public class ChoixObjetsFinauxPourConstDlg extends MtgDlg {
	private JLabel label1, label2, label3;
	private ListeObjetsNumeriquesFinauxPourConst liste;
	private JScrollPane scrollPaneListe;
	private JButton btnOK, btnCancel;

	/**
	 * Constructeur
	 * @param frameInit
	 */
	public ChoixObjetsFinauxPourConstDlg(MtgFrame frameInit) {
		super(getString("choixObjetsFinauxPourConstDlg1"), true, frameInit);
    initComponents();
    getRootPane().setDefaultButton(btnOK);    		
	}
	
  private void initComponents() {
		label1 = new JLabel(getString("choixObjetsFinauxPourConstDlg2"));
		label2 = new JLabel(getString("choixObjetsFinauxPourConstDlg3"));
		label3 = new JLabel(getString("choixObjetsFinauxPourConstDlg4"));
		liste = new ListeObjetsNumeriquesFinauxPourConst(frame);
    scrollPaneListe = new JScrollPane(liste, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
    		JScrollPane.HORIZONTAL_SCROLLBAR_NEVER );
	  btnOK = new javax.swing.JButton(getString("btnOK"));
	  btnOK.addActionListener(new java.awt.event.ActionListener() {
	    public void actionPerformed(java.awt.event.ActionEvent evt) {
	      btnOKActionPerformed();
	    }
	  });    
	  btnCancel = new javax.swing.JButton(getString("btnCancel"));
	  btnCancel.addActionListener(new java.awt.event.ActionListener() {
	    public void actionPerformed(java.awt.event.ActionEvent evt) {
	      btnCancelActionPerformed();
	    }
	  });
	  btnOK.setMaximumSize(btnCancel.getPreferredSize());
    JPanel panePrincipal = new JPanel();
    panePrincipal.setLayout(new GridBagLayout());
    JPanel paneRight = new JPanel();
    paneRight.setLayout(new BoxLayout(paneRight, BoxLayout.Y_AXIS));
    paneRight.add(btnOK);
    paneRight.add(Box.createRigidArea(new Dimension(0,5)));
    paneRight.add(btnCancel);
    
		GridBagConstraints constraints = new GridBagConstraints();
		constraints.insets.bottom = 0;
		constraints.insets.top = 2;
		constraints.insets.left = 5;
		constraints.insets.right = 5;

		// paneMilieu est le JPanel contenant les deux listes de macros et les boutons correspondants
		setConstraints(constraints, 0, 0, 1, 1, 80, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
		panePrincipal.add(label1, constraints);
		setConstraints(constraints, 0, 1, 1, 1, 0, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
		panePrincipal.add(label2, constraints);
		setConstraints(constraints, 0, 2, 1, 1, 0, 10, GridBagConstraints.NONE, GridBagConstraints.WEST);
		panePrincipal.add(label3, constraints);
		setConstraints(constraints, 0, 3, 1, 1, 0, 90, GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST);
		panePrincipal.add(scrollPaneListe, constraints);
 		setConstraints(constraints, 1, 0, 1, 4, 20, 0, GridBagConstraints.BOTH, GridBagConstraints.WEST);
		panePrincipal.add(paneRight, constraints);
		
		setContentPane(panePrincipal);
		pack();
		
  }
  
  private void btnOKActionPerformed() {
  	MtgInternalFrame cadre = frame.cadreActif();
  	cadre.listeObjetsFinauxNG.retireTout();
   	for (int i = 0; i < liste.pointeurs.size(); i++) {
  		if (liste.isSelectedIndex(i)) cadre.listeObjetsFinauxNG.add(liste.pointeurs.get(i));
  	}
  	setRetourOK(true);
  	dispose();
  }
  
  private void btnCancelActionPerformed() {
  	dispose();
  }
  
}
