/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package dialogs;

import mathgraph32.MtgFrame;
import objets.CElementBase;
import objets.CValeurAssocieeAVariable;

/**
 *  Editeur du nombre de termes d'une suite rcurrente pour les botes de dialogue.
 *  Le nombre doit tre entier et compris entre 2 et 500
 * @author Yves
 *
 */
@SuppressWarnings("serial")
public class EditeurNombreTermesSuiteRec extends EditeurValeurDynamique {
	public static final double nombreTermesMaxi = 500;

  public EditeurNombreTermesSuiteRec(MtgFrame frameInit, CValeurAssocieeAVariable valInit, CElementBase objetInit) {
    super(frameInit,  valInit,  objetInit); 
  }
  
  /**
   * Fonction charge de vrifier si la rponse, quand elle est correcte, est valide
   * pour le type de valeur attendu. Par exemple, le rayon d'un cercle doit tre non nul.
   * Renvoie true par dfaut et doit tre redfinie pour tous les descendants.
   *
  */
  public boolean valeurAcceptee(double v) {
    if ((v < 2) || (v>500) || (v != Math.floor(v)))  {
      frame.dialogueAvertissement(MtgFrame.getString("ch71"));
      requestFocus();
      return false;
    }
    else return true;
  }
  
	
}
