/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package dialogs;

import java.util.Vector;
import javax.swing.JList;
import javax.swing.ListSelectionModel;
import objets.CMathGrafDoc;
import objets.CPrototype;

/**
 * Liste affichant tous les noms des prototypes inclus dans le document doc
 * @author Yves
 *
 */
@SuppressWarnings("serial")
public class ListePrototypes extends JList<String> {
	private CMathGrafDoc doc;
	
	public ListePrototypes(CMathGrafDoc docInit) {
		super();
		doc = docInit;
    setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    Vector<String> values = new Vector<String> ();
    for (int i = 0; i < doc.tablePrototypes.size(); i++) {
    	values.add(doc.tablePrototypes.get(i).nom);
    }
    setListData(values);
    setVisibleRowCount(6);
    setSelectedIndex(0);
	}

	public CPrototype prototypeChoisi() {
		return doc.tablePrototypes.get(getSelectedIndex());
	}
	
  public void setSel(CPrototype proto) {
  	int ind = doc.tablePrototypes.indexOf(proto);
  	setSelectedIndex(ind);
  }
	
}
