
/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package dialogs;

import java.awt.event.ActionEvent;

import javax.swing.JTextArea;
/**
 * Classe implmentant un bouton servant  onsrer un code Latex dans un commentaire
 * @author Yves
 *
 */
@SuppressWarnings("serial")
public class MtgLatexButtonPourCommentaire extends MtgLatexButton {
  public MtgLatexButtonPourCommentaire(String nomFichierInit, String chaineLatexInit, int indiceInsertionInit, JTextArea textareaInit) {
  	super(nomFichierInit, chaineLatexInit, indiceInsertionInit, textareaInit);
  }

	public void actionPerformed(ActionEvent e) {
	  String ch = textarea.getText();
		String selection = textarea.getSelectedText();
	  int i = textarea.getCaretPosition();
	  // On regarde si le point d'insertion est prcd et suivi d'un caractre $.
	  // Si ce n'est pas le cas, on rajoute un caractre $ en dbut et en fin (dlimiteur LaTex)
	  boolean dollargauche = false;
	  boolean dollardroit = false;
	  if (selection == null) {
		  for (int j = i-1; (j>=0) && !dollargauche; j--) {
		  	if (ch.charAt(j) == '$') dollargauche = true;
		  }
		  for (int j = i+1; (j < ch.length()) && !dollardroit; j++) {
		  	if (ch.charAt(j) == '$') dollardroit = true;
		  }
	  }
	  else {
		  for (int j = textarea.getSelectionStart() - 1; (j>=0) && !dollargauche; j--) {
		  	if (ch.charAt(j) == '$') dollargauche = true;
		  }
		  for (int j = textarea.getSelectionEnd(); (j < ch.length()) && !dollardroit; j++) {
		  	if (ch.charAt(j) == '$') dollardroit = true;
		  }
	  }
	  String chaineAInserer;
	  int indiceReelInsertion;
	  if (dollargauche && dollardroit) {
	  	chaineAInserer = chaineLatex;
	  	indiceReelInsertion = indiceInsertion;
	  }
	  else {
	  	chaineAInserer = "$"+ chaineLatex + "$";
	  	indiceReelInsertion = indiceInsertion + 1;
	  }
		if (selection != null) {
			// On retire les ventuels caractres $ contenus dans la slection
			int j;
			while ((j = selection.indexOf('$')) != -1) {
				if (j == 0) selection = selection.substring(1);
				else {
					int len = selection.length();
					if (j == len - 1) selection = selection.substring(0, len - 1);
					else selection = selection.substring(0, j) + selection.substring(j+1);
				}
			}
			textarea.setText(ch.substring(0,textarea.getSelectionStart()) + chaineAInserer.substring(0, indiceReelInsertion)
					+ selection + chaineAInserer.substring(indiceReelInsertion)
					+ ch.substring(textarea.getSelectionEnd()));
		}
		else {
	    String ch2 = ch.substring(0, i) + chaineAInserer + ch.substring(i);
	    textarea.setText(ch2);
		}
		if (selection != null) textarea.setCaretPosition(textarea.getText().length());
		else {
			int indcaret = i + indiceInsertion;
	    if (dollargauche && dollardroit) textarea.setCaretPosition(indcaret);
	    else textarea.setCaretPosition(indcaret+1);
		}
    // On informa la fentre propritaire qu'elle doit si ncessaire remettre  jour
    //l'affichage clignotant (pour CommentaireDlg et LatexDlg)
    MtgDlg owner = (MtgDlg) (textarea.getTopLevelAncestor());
    owner.metAJourAffichageClignotant();
    textarea.requestFocus();
	}  
}
