/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package dialogs;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JLabel;
import javax.swing.JRadioButton;

import types.UniteAngle;

import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

@SuppressWarnings("serial")
public class PaneOptionsFigureChoixUniteAngle extends PaneOptionsFigure {
	private JLabel label1, label2, label3;
	JRadioButton radioRadian;
	JRadioButton radioDegre;
	ButtonGroup btnGroup;
	
	/**
	 * Constructeur
	 */
	public PaneOptionsFigureChoixUniteAngle(MtgInternalFrame cadreInit) {
		super(cadreInit);
		initComponents();
		radioRadian.setSelected(cadreInit.listePr.uniteAngle == UniteAngle.Radian);
		radioDegre.setSelected(cadreInit.listePr.uniteAngle == UniteAngle.Degre);
	}
	
	private final void initComponents() {
		label1 = new JLabel(MtgFrame.getString("uniteAngleFigEnCours"));
		label2 = new JLabel(MtgFrame.getString("ch167"));
		label3 = new JLabel(MtgFrame.getString("ch168"));
		radioRadian = new JRadioButton(MtgFrame.getString("radioRadian"));
		radioDegre = new JRadioButton(MtgFrame.getString("radioDegre"));
		btnGroup= new ButtonGroup();
		btnGroup.add(radioRadian);
		btnGroup.add(radioDegre);
		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		add(label1);
		add(radioDegre);
		add(radioRadian);
		add(label2);
		add(label3);		
		setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
	}
	
	public boolean sauveDonnees() {
		boolean modifie = (radioRadian.isSelected() && (cadre.listePr.uniteAngle == UniteAngle.Degre))
										|| (radioDegre.isSelected() && (cadre.listePr.uniteAngle == UniteAngle.Radian));
		cadre.listePr.uniteAngle = radioRadian.isSelected() ? UniteAngle.Radian : UniteAngle.Degre;
		MtgFrame frame = cadre.frame;
		frame.listeObjetsVisuels.uniteAngle = radioRadian.isSelected() ? UniteAngle.Radian : UniteAngle.Degre;
		if (modifie) frame.labelUniteAngle.setText( radioDegre.isSelected() ? MtgFrame.getString("radioDegre") : MtgFrame.getString("radioRadian"));
		return modifie;
	}
	
	public String titreOnglet() {
		return MtgFrame.getString("ongletUniteAngle");
	}	
}
