/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package mathgraph32;

import java.awt.Dimension;
import java.awt.Toolkit;
import java.io.IOException;
import org.scilab.forge.jlatexmath.TeXFormula;

/**
 *
 * @author Yves
 */
public class Main {
  
  /** Creates a new instance of Main */
  public Main() {
  }
  
  /**
   * @param args the command line arguments
   */
  public static void main(String[] args) {
    // TODO code application logic here
    try {
    	/*
    	UIDefaults dd = UIManager.getDefaults();
    	for (Enumeration<Object> e = dd.keys() ; e.hasMoreElements() ;) {
    	    Object obj = e.nextElement();
    	    if (obj.toString().endsWith("font"))
    	        UIManager.put(obj,new Font("Arial",Font.PLAIN,20));
    	}
    	 */
    	boolean avecFigureVierge;
    	if (args.length != 0) {
    		avecFigureVierge = (args[0].length() == 0);
    	}
    	else avecFigureVierge = true;
    	MtgFrame  fenetrePrincipale = new MtgFrame(avecFigureVierge);

 	    Dimension dimfen = new Dimension();
	    // On cherche la rsolution de l'cran
	    Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
	    if (dim.width <= 800) {
	    	dimfen.width = dim.width;
	    	dimfen.height = dim.height - 30;
	    }
	    else {
		    if (dim.width <= 1024) {
		    	dimfen.width = 950;
		    	dimfen.height = dim.height - 30;
		    }
		    else {
		    	dimfen.width = (int) (dim.width*0.85);
		    	dimfen.height = (int) (dim.height*0.9);
		    }
	    }
	    fenetrePrincipale.setSize(dimfen);
	    // Pour viter un bug de nullPointerException rcursif : 
	    TeXFormula.registerFonts(false);
			// On cre une formule latex pour initialiser tous les fichiers associs
			// et on en profite pour crer un alias de la commande \jlmDynamic qui sert aux insertions dynamiques
	    /* Supprim version 4.7.4
			@SuppressWarnings("unused")
			TeXFormula formula = new TeXFormula("\\newcommand{\\Val}[1]{\\jlmDynamic{\0Val\0#1}}");
			formula = new TeXFormula("\\newcommand{\\For}[1]{\\jlmDynamic{\0For\0#1}}");// Ajout version 4.5.2
			formula = new TeXFormula("\\newcommand{\\ForSimp}[1]{\\jlmDynamic{\0ForSimp\0#1}}");// Ajout version 4.6
			formula = new TeXFormula("\\newcommand{\\Calc}[1]{\\jlmDynamic{\0Calc\0#1}}");// Ajout version 4.6
			formula = new TeXFormula("\\newcommand{\\CalcSimp}[1]{\\jlmDynamic{\0CalcSimp\0#1}}");// Ajout version 4.6
			formula = new TeXFormula("\\newcommand{\\FracRed}[1]{\\jlmDynamic{\0FracRed\0#1}}");
			formula = new TeXFormula("\\newcommand{\\If}[3]{\\jlmDynamic{\0If\0#1\0#2\0#3}}");
			*/
	    if (!avecFigureVierge) fenetrePrincipale.ouvreFenetreParPath(args[0]);
    }
    catch (IOException e) {
      // On ne fait rien pour laisser la possibilit  l'utilisateur d'enregistrer son travail
    }
  }
  
}
