/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package mathgraph32;

import java.awt.AlphaComposite;
import java.awt.Color;
import java.awt.Composite;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Insets;
import java.awt.RenderingHints;

import javax.swing.JButton;

@SuppressWarnings("serial")
public class MtgColorButtonTransparency extends JButton {
  private MtgFrame frame;
  private static Insets insets = new Insets(0,0,0,0);
  public Color couleur = Color.BLACK; // la couleur du bouton
	private float transparency;
	
	public MtgColorButtonTransparency(MtgFrame frameInit, float transparencyInit) {
    super();
		frame = frameInit;
		transparency = transparencyInit;
    frame = frameInit;
    setMargin(insets);
    setBackground(frame.paneRight.getBackground());
    setPreferredSize(new Dimension(48,24));
	}
	
	public void setTransparency(float newTransparency) {
		transparency = newTransparency;
	}
	
  @Override
  public void paint(Graphics g) {
  	Graphics2D g2D = (Graphics2D)g;
  	setSize(getPreferredSize());
  	setOpaque(false);
  	super.paint(g); // Pour que le rectangle de fond soit transparent
  	g2D.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
  	g2D.setRenderingHint(RenderingHints.KEY_ALPHA_INTERPOLATION, RenderingHints.VALUE_ALPHA_INTERPOLATION_QUALITY);
    Dimension rect = getSize();
		g2D.setColor(couleur);
    Composite originalComposite = g2D.getComposite();
    g2D.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, transparency));
    g2D.fillOval(4, 4, rect.width - 9, rect.height - 9);
    g2D.setComposite(originalComposite);
    // Supprim version 4.6
    // if (couleur == Color.BLACK) g2D.setColor(Color.BLACK);
    // else g2D.setColor(Color.WHITE);
    // g2D.drawOval(4, 4, rect.width - 9, rect.height - 10);

  	/*
  	Graphics2D g2D = (Graphics2D)g;
  	setSize(getPreferredSize());
  	setOpaque(false);
  	super.paint(g); // Pour que le rectangle de fond soit transparent
    Dimension rect = getSize();
		g2D.setColor(couleur);
    Composite originalComposite = g2D.getComposite();
    g2D.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, transparency));
    g2D.fillOval(4, 4, rect.width - 9, rect.height - 10);
    if (couleur != Color.BLACK) g.setColor(Color.BLACK);
    else g2D.setColor(Color.WHITE);
    g2D.drawOval(4, 4, rect.width - 9, rect.height - 10);
    g2D.setComposite(originalComposite);
    */  		
	}
  
  public void donneCouleur(Color coul) {
  	couleur = coul;
  	repaint();
  }
  
}
