/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package mathgraph32;

import java.awt.Insets;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JPanel;
import javax.swing.JToolBar;

import types.StylePoint;

@SuppressWarnings("serial")
public class MtgPaneStylePoint extends JPanel implements MouseListener {
	private MtgFrame frame;
	private static Insets ins = new Insets(0, 0, 0, 0);
	
  public MtgPaneStylePoint(MtgFrame frameInit) {
    super();
    frame = frameInit;
  	// Des boutons servant  dterminer le style des points crs
		MtgStylePointButton buttonStylePointCroix = new MtgStylePointButton(frame, StylePoint.croix);
		MtgStylePointButton buttonStylePointMult = new MtgStylePointButton(frame, StylePoint.mult);
		MtgStylePointButton buttonStylePointPetitRond = new MtgStylePointButton(frame, StylePoint.petitRond);
		MtgStylePointButton buttonStylePointGrandRond = new MtgStylePointButton(frame, StylePoint.grandRond);
		MtgStylePointButton buttonStylePointCarre = new MtgStylePointButton(frame, StylePoint.carre);
		MtgStylePointButton buttonStylePointLosange = new MtgStylePointButton(frame, StylePoint.losange);
  	// Un groupe de boutons pour englober tous les boutons de la barre d'outil de
  	// choix de style de point
  	ButtonGroup btngroupStylePoint = new ButtonGroup();
		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		btngroupStylePoint.add(buttonStylePointCroix);
		btngroupStylePoint.add(buttonStylePointMult);
		btngroupStylePoint.add(buttonStylePointLosange);
		btngroupStylePoint.add(buttonStylePointPetitRond);
		btngroupStylePoint.add(buttonStylePointGrandRond);
		btngroupStylePoint.add(buttonStylePointCarre);
		// On active le petit rond par dfaut comme style de point
		buttonStylePointPetitRond.setSelected(true);
		// Les trois barres d'outils horizontales servant  contenir les icnes de
		// choix de style de point
		JToolBar barStylePoint1 = new JToolBar(JToolBar.HORIZONTAL);
		JToolBar barStylePoint2 = new JToolBar(JToolBar.HORIZONTAL);
		JToolBar barStylePoint3 = new JToolBar(JToolBar.HORIZONTAL);
		barStylePoint1.setMargin(ins);
		barStylePoint2.setMargin(ins);
		barStylePoint3.setMargin(ins);
		barStylePoint1.setFloatable(false);
		barStylePoint2.setFloatable(false);
		barStylePoint3.setFloatable(false);
		barStylePoint1.add(buttonStylePointCroix);
		barStylePoint1.add(buttonStylePointMult);
		barStylePoint2.add(buttonStylePointLosange);
		barStylePoint2.add(buttonStylePointPetitRond);
		barStylePoint3.add(buttonStylePointGrandRond);
		barStylePoint3.add(buttonStylePointCarre);
		barStylePoint1.setBorder(BorderFactory.createEmptyBorder(0, 2, 0, 2));
		barStylePoint2.setBorder(BorderFactory.createEmptyBorder(0, 2, 0, 2));
		barStylePoint3.setBorder(BorderFactory.createEmptyBorder(0, 2, 0, 2));
		add(barStylePoint1);
		add(barStylePoint2);
		add(barStylePoint3);
  }

	public void mouseClicked(MouseEvent arg0) {
	}  
	public void mouseEntered(MouseEvent arg0) {
    if (getCursor() != MtgFrame.defaultCursor) frame.setCursor(MtgFrame.defaultCursor);
	}
	public void mouseExited(MouseEvent arg0) {
	}
	public void mousePressed(MouseEvent arg0) {
	}
	public void mouseReleased(MouseEvent arg0) {
	}  
  
}
