/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package mathgraph32;

import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.ImageIcon;
import javax.swing.JToggleButton;

import types.StyleFleche;


@SuppressWarnings("serial")
public class MtgStyleMarqueSegmentButton extends JToggleButton implements MouseListener, ActionListener {
	private MtgFrame frame;
	private int styleMarqueSegmentAssocie;
  private static Insets insets = new Insets(1,1,1,1);
	/**
	 * Constructeur
	 */
	public MtgStyleMarqueSegmentButton(MtgFrame frameInit, int StyleMarqueSegmentAssocieInit) {
		super(new ImageIcon(MtgFrame.class.getResource("images/" + nomFichierAssocie(StyleMarqueSegmentAssocieInit))));
		setMargin(insets);
		frame = frameInit;
		styleMarqueSegmentAssocie = StyleMarqueSegmentAssocieInit;
    addMouseListener(this);
    addActionListener(this);
    setToolTipText(MtgFrame.getString("tipChoixStyleMarqueSegment"));
	}
	
	public static String nomFichierAssocie(int styleMarque) {
		String ch;
		switch (styleMarque) {
		case StyleFleche.FlecheLonguePleine :
			ch = "StyleMarqueSegment1.png";
			break;
		case StyleFleche.FlecheCourtePleine :
			ch = "StyleMarqueSegment2.png";
			break;
		case StyleFleche.FlecheLongueSimple :
			ch = "StyleMarqueSegment3.png";
			break;
		case StyleFleche.FlecheCourteSimple :
			ch = "StyleMarqueSegment4.png";
			break;
		default : ch = "";
		}
		return ch;
	}

	public void mouseClicked(MouseEvent e) {
	}

	public void mouseEntered(MouseEvent e) {
    if (getCursor() != MtgFrame.defaultCursor) frame.setCursor(MtgFrame.defaultCursor);
	}

	public void mouseExited(MouseEvent e) {
	}

	public void mousePressed(MouseEvent e) {
	}

	public void mouseReleased(MouseEvent e) {
	}

	public void actionPerformed(ActionEvent e) {
		frame.styleMarqueSegmentActif = styleMarqueSegmentAssocie;
	}
}
