package objets;

import mathgraph32.MtgFrame;
import dialogs.MaximumMinimumDlg;
import dialogs.MtgDlg;
import types.DimensionFenetre;
import types.ErreurCalculException;
import types.NatureCalcul;

public class CMinFonc extends CMaxFonc {

	public CMinFonc() {
	}
	
  public CMinFonc(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
      String nomInit, CFonc fonctionAssocieeInit,
      CValeurAssocieeAVariable aInit, CValeurAssocieeAVariable bInit, CValeurAssocieeAVariable incertitudeInit) {
      super(liste, impProtoInit, estElementFinalInit, nomInit, fonctionAssocieeInit, aInit, bInit, incertitudeInit);
    }
    
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(fonctionAssociee);
    int ind2 = listeSource.indexOf(impProto);
    CValeurAssocieeAVariable aClone = (CValeurAssocieeAVariable) a.getClone(listeSource, listeCible);
    CValeurAssocieeAVariable bClone = (CValeurAssocieeAVariable) b.getClone(listeSource, listeCible);
    CValeurAssocieeAVariable incertitudeClone = (CValeurAssocieeAVariable) incertitude.getClone(listeSource, listeCible);
    CElementBase ptelb = new CMinFonc(listeCible, (CImplementationProto)(listeCible.get(ind2, CImplementationProto.class)),
      estElementFinal, nomCalcul, (CFonc)(listeCible.get(ind1, CFonc.class)), aClone,
      bClone, incertitudeClone);
    return ptelb;
  }
  
  @Override
  public long getNatureCalcul() {
  	return NatureCalcul.NMinimumFonction;
  }
  
  @Override
  public void positionne(boolean infoRandom, DimensionFenetre dimfen) {
    double x1,x2,xa,xb,y1,y2,e,h;
    a.positionne(infoRandom, dimfen);
    b.positionne(infoRandom, dimfen);
    incertitude.positionne(infoRandom, dimfen);
    existe = fonctionAssociee.existe && a.existe() && b.existe() && incertitude.existe() ;
    if (!existe) return;
    xa = a.rendValeur(infoRandom);
    xb = b.rendValeur(infoRandom);
    e = incertitude.rendValeur(infoRandom);
    if (xa > xb) {
      double temp = xa;
      xa = xb;
      xb = temp;
    }

    // Contrairement  la mthode de dichotomie, la longueur de l'intervalle est ici multiplie  chaque fois par 2/3
    double nBoucles = Math.floor(Math.log(Math.abs(xb - xa)/e)/Math.log(1.5)) + 1;
    if (nBoucles > 1000) {
      existe = false;
      return;
    }
    h = (xb - xa)/3;
    x1 = xa + h;
    x2 = xb - h;
    for (int i = 1; i <= (int) nBoucles; i ++) {
    	h = (xb - xa)/3;
      x1 = xa + h;
      x2 = xb - h;
      try {
        y1 = fonctionAssociee.rendValeurFonction(infoRandom,x1);
        y2 = fonctionAssociee.rendValeurFonction(infoRandom,x2);
      } catch (ErreurCalculException err) {
        existe = false;
        return;
      }
      if (y1 < y2) xb = x2;
      else xa = x1;
    }
    existe = true;
    valeur = (x1 + x2)/2;
  }
    
  protected String description() {
  	return getString("chinfo177");
  }
  
  @Override
  public MtgDlg dialogueModification(MtgFrame frame) {
  	return new MaximumMinimumDlg(frame, this, true, false);
  } 
  
}
