/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import java.awt.Cursor;
import java.awt.Point;

import objets.CAffichageLieAPoint;
import objets.CCommentaire;
import objets.CElementGraphique;
import objets.CListeObjets;
import types.StyleEncadrement;
import dialogs.CommentaireDlg;
import mathgraph32.MtgFrame;

public class OutilCommentaire extends Outil {
  Point pointDesigne;
  
  /** Creates a new instance of OutilPtLib */
  public OutilCommentaire(MtgFrame frameInit) {
    super(frameInit, true);
  }
    
  @Override
	public Cursor curseurUtilise() {
		return MtgFrame.cornerCursor;
	}

  @Override
	public void select() {
    super.select();
    frame.outilPointageActif = frame.outilPointageClic;
    frame.indication(getString("commentaire1"));
  }
  
  @Override
  public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
    pointDesigne = pointClique;
    creeObjet();
  }
  
  @Override
  public void creeObjet() {
    int x = pointDesigne.x;
    int y = pointDesigne.y;
    CListeObjets liste = frame.cadreActif().listePr;
    // Avant l'affichage du dialogue on cre un message qui sera ajout  la liste des objets clignotants
    // pour matrialiser l'emplacement de l'affichage
    CCommentaire comClignotant = new CCommentaire(liste, null, false, frame.couleurActive(), x, y, 0d, 0d, false, null, 2,
    		StyleEncadrement.Sans, false, frame.cadreActif().couleurFond, getString("ch80"),
				CAffichageLieAPoint.alignementHorizontalGauche, CAffichageLieAPoint.alignementVerticalHaut);
    comClignotant.positionne(false, frame.cadreActif().dimf);
    ajouteClignotementDe(comClignotant);
    resetClignotement();
    CCommentaire com = new CCommentaire(liste, null, false, frame.couleurActive(),
    		x, y, 0d, 0d, false, null, frame.pref_IndiceTaillePoliceAffichages, StyleEncadrement.Sans, false, frame.cadreActif().couleurFondAffichage, null,
				CAffichageLieAPoint.alignementHorizontalGauche, CAffichageLieAPoint.alignementVerticalHaut);
    
    frame.indication("");
    CommentaireDlg dlg = new CommentaireDlg(frame, com, false,comClignotant);
    // dlg.setLocationRelativeTo(frame); Inutile depuis la version 3.2.9 car setVisible est redfini pour CommentaireDlg
    // de faon que le dialogue soit plac le plus  droite possible de la fentre.
		dlg.setLocationRelativeTo(frame);
    dlg.setVisible(true);
    if (dlg.retourOK()) {
	    if (frame.ajouteElementAvecVerification(com)) {
	    	annuleClignotement();
	      frame.cadreActif().gestionnaire.enregistreFigureEnCours(getString("chaineOutil54"));
	      frame.cadreActif().repaintFigureAvecCalcul();
	    }
    }
    annuleClignotement();
    select();
  }
}
