package outils;

import java.awt.Point;

import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;
import objets.CElementGraphique;
import objets.CListeObjets;
import objets.CPointAncetre;
import types.NatureObjet;

public class OutilDemarquerPointPourTrace extends Outil {
	private int nbPointsDesignes;
	private boolean sauveModeTrace;
	public OutilDemarquerPointPourTrace(MtgFrame frameInit) {
		super(frameInit, true);
	}

  @Override
	public void select() {
		super.select();
		nbPointsDesignes = 0;
		MtgInternalFrame cadre = frame.cadreActif();
		sauveModeTrace = cadre.document.modeTraceActive;
		cadre.activeModeTrace(false);
		CListeObjets liste = frame.cadreActif().listePr;
		frame.listeClignotante.ajoutePointsMarquesPourTrace(liste, true);// Ajoute les points qui sont marqus pour la trace	
		frame.outilPointageActif = frame.outilPointageObjetClignotant;
		frame.outilPointageActif.designationDe(NatureObjet.NToutPoint);
		frame.indication(getString("demarquagePointPourTrace"));
		resetClignotement();		
	}
  
	public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
		nbPointsDesignes++;
		frame.listeClignotante.remove(elg);
    ((CPointAncetre) elg).marquePourTrace = false;
    if (frame.listeClignotante.size() == 0) frame.activeOutilCapture();
    else resetClignotement();
  }
	
	@Override
	public void creeObjetApresClicDroit() {
   MtgInternalFrame cadre = frame.cadreActif();
   if (nbPointsDesignes != 0) {
    	cadre.gestionnaire.enregistreFigureEnCours(getString("chaineOutil150"));
    }
    cadre.activeModeTrace(sauveModeTrace);
    frame.activeOutilCapture();
	}

}
