/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import objets.*;
import types.StyleMarqueAngle;
import types.StyleTrait;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

public class OutilDtPer extends OutilParDtPt {
  
  /** Creates a new instance of OutilDtePer */
  public OutilDtPer(MtgFrame frameInit) {
    super(frameInit);
  }
  
  @Override     
  public void creeObjet() {
  	MtgInternalFrame cadre = frame.cadreActif();
  	CListeObjets liste = cadre.listePr;
    CDroitePerpendiculaire pt = new CDroitePerpendiculaire(liste, null,
       false, frame.couleurActive(), frame.styleTraitActif(), point1, droite1, frame.pref_indiceTaillePoliceNom);
    if (frame.ajouteElementAvecVerification(pt)) {
    	// Modification version 4.3 : On affiche une parque d'angle droit si dans les prfrences
    	// on demande l'affichage automatique des mesures
     	// if (frame.pref_niveau >= MtgFrame.niveauMoyen) {
    	if (frame.pref_affichageMesuresNiveau[frame.pref_niveau]) {
        CMarqueAngleDroit marque = new CMarqueAngleDroit(liste, null, false, frame.couleurActive(),
        		false, StyleTrait.traitFin, StyleMarqueAngle.marqueSimple, 9d, pt);
        marque.positionne(false, cadre.dimf);
        frame.ajouteElement(marque);
    	}
      frame.cadreActif().gestionnaire.enregistreFigureEnCours(getString("chaineOutil9"));
    }
    annuleClignotement();
    select();
  }
  
  /** Mthode ajoutant les objets visuels  la liste listeObjetsVisuels de l'applet
   * au fur et  mesure que l'on dsigne les obejts  la souris
   * Doit tre redfini pour chaque outil utilisant une aide visuelle  la cration
   */
  @Override     
  public void ajouteObjetsVisuels() {
    CDroitePerpendiculaire dt = new CDroitePerpendiculaire(frame.listeObjetsVisuels,
      null, false, frame.couleurActive(), frame.styleTraitActif(),
      frame.cadreActif().paneFigure.pointSouris, droite1, 2);
    CMarqueAngleDroit marque = new CMarqueAngleDroit(frame.listeObjetsVisuels, null, false, frame.couleurActive(),
    		false, StyleTrait.traitFin, StyleMarqueAngle.marqueSimple, 9d, dt);
    frame.listeObjetsVisuels.add(dt);
    frame.listeObjetsVisuels.add(marque);
  }
  
  @Override     
  public String chaineIndication (int indEtape) {
    switch(indEtape) {
      case 1 : return getString("perpendiculaire1");
      case 2 : return getString("perpendiculaire2");
      default: return "";
    }
  }
}