/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import java.awt.Insets;
import java.awt.Point;

import dialogs.HistoriqueDlg;

import mathgraph32.MtgFrame;


/**
 * Outil afichant une bote de dialogue flottante prsentant dans l'ordre tous les objets crs
 * @author Yves
 */
public class OutilHistorique extends Outil {
  public OutilHistorique(MtgFrame frameInit) {
    super(frameInit, true);
  }
  
  @Override
  public void select() {
    super.select();
    HistoriqueDlg histdlg = frame.historiqueDlg;
    histdlg.reset();
    frame.outilPointageActif = frame.outilPointageHistorique;
    frame.outilPointageActif.reset();
    frame.cadreActif().paneFigure.repaint();
    Point pt = frame.mtgDesktopPane.getLocationOnScreen();
    int height = frame.mtgDesktopPane.getHeight();
  	Insets insets = histdlg.getInsets();
    frame.historiqueDlg.setLocation(pt.x + insets.left, pt.y + height - frame.historiqueDlg.getHeight() - insets.bottom);
    frame.historiqueDlg.setVisible(true);
  }
}
