/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import objets.CListeObjets;
import objets.CPointDansRepere;
import objets.CValeurAssocieeAVariable;
import types.NatureCalcul;
import types.NatureObjet;
import dialogs.CoordonneesDlg;
import mathgraph32.MtgFrame;


@SuppressWarnings("unused")
public class OutilPointParCoordonnees extends Outil {
  public OutilPointParCoordonnees(MtgFrame frameInit) {
    super(frameInit, false);
  }
  
   
  @Override
	public boolean activationValide() {
		return frame.cadreActif().listePr.nombreObjetsParNatureCalculNonIntermediaires(NatureCalcul.NRepere)>0;
	}
	
	@Override
	public String messageActivationNonValide() {
		return getString("messagePasDeRepere");
	}	
  
  @Override
  public void select() {
    super.select();
    frame.indication("");
    CListeObjets liste = frame.cadreActif().listePr;
    
    CPointDansRepere point = new CPointDansRepere(frame.cadreActif().listePr, null, false, frame.couleurActive(),
    		false, 0d, 0d, false, frame.genereNomPourPoint(), frame.pref_indiceTaillePoliceNom,
    		frame.stylePointActif, null, new CValeurAssocieeAVariable(liste, 1d),
    		new CValeurAssocieeAVariable(liste, 1d), false);
    CoordonneesDlg dlg = new CoordonneesDlg(frame, point, false);
		dlg.setLocationRelativeTo(frame);
    dlg.setVisible(true);
    if (dlg.retourOK()) {
      if (frame.ajouteElementAvecVerification(point)) {
        frame.cadreActif().gestionnaire.enregistreFigureEnCours(getString("chaineOutil41"));
        frame.cadreActif().repaintFigureAvecCalcul();
      }
    }
    frame.activeOutilCapture();
    point = null;
  } 
}
