/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package outils;

import java.awt.Image;
import java.awt.event.MouseEvent;

import objets.CListeObjets;
import objets.CMathGrafDoc;
import objets.CPointAncetrePointsMobiles;
import objets.CPointBase;
import objets.CPointBaseEnt;
import objets.CPointLie;
import types.NatureObjet;
import mathgraph32.MtgFrame;
import mathgraph32.MtgInternalFrame;

public class OutilPointageTraceObjet extends OutilPointageCapt {

  /** Creates a new instance of OutilPointageCapt */
  public OutilPointageTraceObjet(MtgFrame frameInit) {
    super(frameInit);
  }
  
  @Override
  public void reset() {
    super.reset();
    MtgInternalFrame cadre = frame.cadreActif();
    cadre.initialisetbuffer();
    CMathGrafDoc doc = cadre.document;
		Image imageFond = doc.imageFond;
		if ((imageFond != null) && doc.imageFondVisible) cadre.tbuffer.drawImage(imageFond, 0, 0, cadre);    
  }
  
  
  @Override
  public void mousePressed(MouseEvent mouseEvent, MtgInternalFrame cadre) {
  	super.mousePressed(mouseEvent, cadre);
  	frame.cadreActif().videDesignation();
  	frame.outilTraceObjets.annuleClignotement();
  	if (deplacementEnCours) {
  		frame.listeClignotante.add(elementCapture);
  		frame.outilTraceObjets.resetClignotement();  		
  	}
  }
  
  public void actionDansPaint(MtgInternalFrame cadre) {
  	CMathGrafDoc doc = cadre.document;
		Outil outilActif = frame.outilActif;
  	if (!deplacementEnCours) {
	    cadre.transferetbufferversgbuffer();
  	}
  	else {
	  	if (elementCapture.getNature() == NatureObjet.NPointLie) ((CPointLie)elementCapture).donneAbscisse(pointabs.getValue());
	  	else
	      if ((natureElementCapture & (NatureObjet.NPointBase | NatureObjet.NPointBaseEnt)) != 0) 
	      		((CPointAncetrePointsMobiles) elementCapture).placeEn(pointres.x, pointres.y);
	    cadre.listeDependantsDansPrincipale.positionne(cadre.infRand, cadre.dimf);
	    frame.outilTraceObjets.ListeATracer.afficheToutSansNom(cadre.tbuffer, cadre.dimf, true,
	    		doc.couleurFond, doc.transparencePourSurfaces, frame.pref_antialiasing);
	    cadre.transferetbufferversgbuffer();
  	}
  	// Gestion du clignotement
		if (outilActif.timer != null) {
    	if (outilActif.nbClignPair) {
    		cadre.listePr.afficheToutSaufElementsDe(cadre.gbuffer, frame.cadreActif().dimf, true, doc.couleurFond,
    			doc.transparencePourSurfaces, frame.listeClignotante, frame.pref_antialiasing);
    		frame.listeClignotante.afficheTout(cadre.gbuffer, frame.cadreActif().dimf, true, doc.couleurFond,
    			doc.transparencePourSurfaces, frame.pref_antialiasing);
    	}
    	else cadre.listePr.afficheToutSaufElementsDe(cadre.gbuffer, cadre.dimf, true, doc.couleurFond,
    			doc.transparencePourSurfaces, frame.listeClignotante, frame.pref_antialiasing);
		}
		else cadre.afficheToutDansgbuffer();
  	
		aRedessinerDansPaint = false;
  }
  
  @Override
  public void mouseDragged(java.awt.event.MouseEvent mouseEvent, MtgInternalFrame cadre) {
    int x = mouseEvent.getX();
    int y = mouseEvent.getY();
    //  revoir
    if ((x > cadre.dimf.longueurAbscisses) || (y > cadre.dimf.longueurOrdonnees)) {
      return;
    }
    if (elementCapture != null){
      if (natureElementCapture == NatureObjet.NPointLie) {
        CPointLie ptPointLie = (CPointLie)(elementCapture);
        deplacementEnCours = ptPointLie.testDeplacement(cadre.dimf,x,y,pointres,pointabs);
        if (deplacementEnCours) {
	        aRedessinerDansPaint = true;
	        cadre.paneFigure.repaint();
        }
      }
      else {
        if (natureElementCapture == NatureObjet.NPointBase) {
          CPointBase ptbase = (CPointBase) elementCapture;
          deplacementEnCours = ptbase.testDeplacement(cadre.dimf,x,y,pointres,pointabs);
          if (deplacementEnCours) {
  	        ptbase.placeEn(pointres.x, pointres.y);
  	        aRedessinerDansPaint = true;
  	        cadre.paneFigure.repaint();
          }
        }
        else {
        	if (natureElementCapture == NatureObjet.NPointBaseEnt) {
	          CPointBaseEnt ptbaseEnt = (CPointBaseEnt) elementCapture;
	          deplacementEnCours = ptbaseEnt.testDeplacement(cadre.dimf,x,y,pointres,pointabs);
	          if (deplacementEnCours){
	  	        aRedessinerDansPaint = true;
	  	        cadre.paneFigure.repaint();
	          }      
	        }
        }
      }
    }
  }
  
  @Override
  public void mouseReleased(MouseEvent mouseEvent, MtgInternalFrame cadre) {
  	if (deplacementEnCours || (elementCapture != null)) {
  		frame.outilTraceObjets.annuleClignotement();
  		frame.listeClignotante.add(elementCapture);
  		frame.outilTraceObjets.resetClignotement();
  		deplacementEnCours = false;
  	}
  }
	
  @Override
  public CListeObjets listeUtilisee() {
  	return frame.listeClignotante;
  }
}
