/*
MathGraph32 Java. Software for creating and animating dynamic mathematics figures
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package types;
import objets.CElementBase;
import objets.CElementGraphique;
import objets.CPointAncetre;

/**
 *
 * @author  Yves
 * @version 
 */
// Classe servant  connatre les objets proches de la souris
public class InfoProx {
  public int nombreObjetsProches;
  public byte nombreTypesProches;
  public CElementBase objetProche;	// Pointe sur le dernier objet
                          // proche rencontr
  public long typesProches;	// masque. 1 bit par type
  /// Pour la conversion  partie du pascal, je prens un indice de plus
  /// inutile pour la commodit
  //Info_Par_Type:	Array [1..NombreTypesDesignables] of RInfoObjetsVoisins;
  public RInfoObjetsVoisins[] infoParType;
  public boolean premierPointVoisinRencontre;
  public CPointAncetre premierPointVoisin;
  public CPointAncetre dernierPointVoisin;
  public int nombrePointsVoisins;
  /** Creates new Class */
  public InfoProx () {
    infoParType = new RInfoObjetsVoisins [NatureObjet.nombreTypesDesignables];
    for (int i =0; i < NatureObjet.nombreTypesDesignables; i++) {
      infoParType[i] = new RInfoObjetsVoisins();
    }
  }
  public void MetAZero() {
    nombreObjetsProches = 0;
    nombrePointsVoisins = 0;
    typesProches = 0;
    objetProche = null;
    premierPointVoisinRencontre = true;
    premierPointVoisin = null;
    dernierPointVoisin = null;
    for (int ind = 0; ind < NatureObjet.nombreTypesDesignables; ind++)
    {
      infoParType[ind].nombreVoisins = 0;
      infoParType[ind].premierVoisin = null;
      infoParType[ind].dernierVoisin = null;
      infoParType[ind].premierVoisinRencontre = true;
    }
  }
  
  // Ajout version 2.7.0
  public void MetAZeroObjetsNonPoints() {
    for (int ind = 0; ind < NatureObjet.nombreTypesDesignables; ind++) {
    	if ((NatureObjet.conversionNumeroNature[ind] & NatureObjet.NToutPoint) == 0) {
        infoParType[ind].nombreVoisins = 0;
        infoParType[ind].premierVoisin = null;
        infoParType[ind].dernierVoisin = null;
        infoParType[ind].premierVoisinRencontre = true;    		
    	}
    }
  }
  
  public int nombreTypesPointsMobilesProches() {
  	int res = 0;
  	long typ = 1;
    for (int i = 0; i < NatureObjet.nombreTypesDesignables; i++) {
    	typ = NatureObjet.conversionNumeroNature[i];
      if (((typ & NatureObjet.NPointMobile) != 0) && (infoParType[i].nombreVoisins > 0)) res++;
    }
    return res;
  }
  
  public CElementGraphique premierVoisin() {
  	CElementGraphique elg = null;
    for (int i = 0; (i < NatureObjet.nombreTypesDesignables) && (elg == null); i++) {
    	if (infoParType[i].nombreVoisins > 0) elg = infoParType[i].premierVoisin;
    }
    return elg;
  }

  public CElementGraphique dernierVoisin() {
  	CElementGraphique elg = null;
    for (int i = NatureObjet.nombreTypesDesignables - 1; (i >= 0) && (elg == null); i--) {
    	if (infoParType[i].nombreVoisins > 0) {
    		if (infoParType[i].dernierVoisin == null) elg = infoParType[i].premierVoisin;
    		else elg = infoParType[i].dernierVoisin;
    	}
    }
    return elg;
  }
}
